"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var moment = require('moment');
var keycode = require('keycode');
var PropTypes = require('prop-types');
var Icon = require('../Icon');
var Selector = /*#__PURE__*/function (_React$Component) {
  _inherits(Selector, _React$Component);
  var _super = _createSuper(Selector);
  function Selector() {
    var _this;
    _classCallCheck(this, Selector);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "styles", function () {
      return {
        container: {
          display: 'flex',
          justifyContent: 'space-between',
          alignItems: 'center'
        },
        calendarHeaderNav: {
          cursor: 'pointer'
        },
        currentDate: {
          padding: '0px 10px'
        }
      };
    });
    return _this;
  }
  _createClass(Selector, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var styles = this.styles();
      var getTranslation = this.props.getTranslation;
      return /*#__PURE__*/React.createElement("div", {
        className: "mx-selector",
        style: _objectSpread(_objectSpread({}, styles.container), this.props.style)
      }, /*#__PURE__*/React.createElement("a", {
        "aria-label": getTranslation(this.props.type === 'Month' ? 'Previous Month' : 'Previous Year'),
        className: "mx-selector-previous",
        onClick: this.props.handlePreviousClick,
        onKeyUp: function onKeyUp(e) {
          return keycode(e) === 'enter' && _this2.props.handlePreviousClick(e);
        },
        role: "button",
        tabIndex: 0
      }, /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.calendarHeaderNav,
        type: "caret-left"
      })), /*#__PURE__*/React.createElement("h2", {
        "aria-label": getTranslation('Currently in %1', this.props.currentDate),
        className: "mx-selector-current-date",
        style: styles.currentDate
      }, this.props.currentDate), /*#__PURE__*/React.createElement("a", {
        "aria-label": getTranslation(getTranslation(this.props.type === 'Month' ? 'Next Month' : 'Next Year')),
        className: "mx-selector-next",
        onClick: this.props.handleNextClick,
        onKeyUp: function onKeyUp(e) {
          return keycode(e) === 'enter' && _this2.props.handleNextClick(e);
        },
        role: "button",
        tabIndex: 0
      }, /*#__PURE__*/React.createElement(Icon, {
        size: 20,
        style: styles.calendarHeaderNav,
        type: "caret-right"
      })));
    }
  }]);
  return Selector;
}(React.Component);
_defineProperty(Selector, "propTypes", {
  currentDate: PropTypes.string,
  getTranslation: PropTypes.func,
  handleNextClick: PropTypes.func,
  handlePreviousClick: PropTypes.func,
  setCurrentDate: PropTypes.func,
  type: PropTypes.string
});
var MonthSelector = /*#__PURE__*/function (_React$Component2) {
  _inherits(MonthSelector, _React$Component2);
  var _super2 = _createSuper(MonthSelector);
  function MonthSelector() {
    var _this3;
    _classCallCheck(this, MonthSelector);
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this3), "_handlePreviousClick", function () {
      var currentDate = moment.unix(_this3.props.currentDate).startOf('month').subtract(1, 'm').unix();
      _this3.props.setCurrentDate(currentDate);
    });
    _defineProperty(_assertThisInitialized(_this3), "_handleNextClick", function () {
      var currentDate = moment.unix(_this3.props.currentDate).endOf('month').add(1, 'd').unix();
      _this3.props.setCurrentDate(currentDate);
    });
    _defineProperty(_assertThisInitialized(_this3), "styles", function () {
      return {
        monthSelector: {
          width: '60%'
        }
      };
    });
    return _this3;
  }
  _createClass(MonthSelector, [{
    key: "render",
    value: function render() {
      var styles = this.styles();
      return /*#__PURE__*/React.createElement(Selector, _extends({}, this.props, {
        currentDate: moment.unix(this.props.currentDate).format('MMMM'),
        handleNextClick: this._handleNextClick,
        handlePreviousClick: this._handlePreviousClick,
        style: styles.monthSelector,
        type: "Month"
      }));
    }
  }]);
  return MonthSelector;
}(React.Component);
_defineProperty(MonthSelector, "propTypes", {
  currentDate: PropTypes.number,
  setCurrentDate: PropTypes.func
});
var YearSelector = /*#__PURE__*/function (_React$Component3) {
  _inherits(YearSelector, _React$Component3);
  var _super3 = _createSuper(YearSelector);
  function YearSelector() {
    var _this4;
    _classCallCheck(this, YearSelector);
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }
    _this4 = _super3.call.apply(_super3, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this4), "_handlePreviousClick", function () {
      var currentDate = moment.unix(_this4.props.currentDate).startOf('month').subtract(1, 'y').unix();
      _this4.props.setCurrentDate(currentDate);
    });
    _defineProperty(_assertThisInitialized(_this4), "_handleNextClick", function () {
      var currentDate = moment.unix(_this4.props.currentDate).endOf('month').add(1, 'y').unix();
      _this4.props.setCurrentDate(currentDate);
    });
    return _this4;
  }
  _createClass(YearSelector, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(Selector, _extends({}, this.props, {
        currentDate: moment.unix(this.props.currentDate).format('YYYY'),
        handleNextClick: this._handleNextClick,
        handlePreviousClick: this._handlePreviousClick,
        type: "Year"
      }));
    }
  }]);
  return YearSelector;
}(React.Component);
_defineProperty(YearSelector, "propTypes", {
  currentDate: PropTypes.number,
  setCurrentDate: PropTypes.func
});
module.exports = {
  MonthSelector: MonthSelector,
  YearSelector: YearSelector
};