"use strict";

var _cssinjs = require("@mxenabled/cssinjs");
var _Theme = require("./Theme");
var _excluded = ["disabled", "onChange"];
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var React = require('react');
var PropTypes = require('prop-types');
var _uniqueId = require('lodash/uniqueId');
var _merge = require('lodash/merge');
var _get = require('lodash/get');
var Column = require('../components/grid/Column');
var Container = require('../components/grid/Container');
var Row = require('../components/grid/Row');
var _require = require('../constants/App'),
  themeShape = _require.themeShape;
var StyleUtils = require('../utils/Style');
var DisplayInput = /*#__PURE__*/function (_React$Component) {
  _inherits(DisplayInput, _React$Component);
  var _super = _createSuper(DisplayInput);
  function DisplayInput() {
    var _this;
    _classCallCheck(this, DisplayInput);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "_isLargeOrMediumWindowSize", function (theme) {
      var windowSize = StyleUtils.getWindowSize(theme.BreakPoints);
      return windowSize === 'large' || windowSize === 'medium';
    });
    _defineProperty(_assertThisInitialized(_this), "_getInputColumns", function (hasLabel, showHint) {
      if (showHint && hasLabel) {
        return {
          large: 8,
          medium: 7,
          small: 12
        };
      }
      if (showHint || hasLabel) {
        return {
          large: 10,
          medium: 9,
          small: 12
        };
      }
      return {
        large: 12,
        medium: 12,
        small: 12
      };
    });
    _defineProperty(_assertThisInitialized(_this), "styles", function (theme, isLargeOrMediumWindowSize) {
      var wrapperFocus = {
        borderBottom: _this.props.valid ? '1px solid ' + theme.Colors.PRIMARY : '1px solid ' + theme.Colors.DANGER,
        boxShadow: 'none',
        outline: 'none'
      };
      return _merge({}, {
        error: {
          color: theme.Colors.DANGER
        },
        hint: {
          color: theme.Colors.PRIMARY,
          height: 20,
          paddingTop: 15,
          textAlign: 'right'
        },
        input: {
          backgroundColor: 'transparent',
          border: 0,
          color: theme.Colors.GRAY_700,
          fontSize: theme.FontSizes.LARGE,
          lineHeight: 1,
          textAlign: 'left',
          width: '100%',
          '&:focus': {
            boxShadow: 'none',
            outline: 'none'
          }
        },
        inputWrapper: {
          alignItems: 'center',
          display: 'flex',
          padding: theme.Spacing.SMALL
        },
        children: {
          alignItems: 'center',
          color: theme.Colors.GRAY_700,
          display: 'flex',
          fontSize: theme.FontSizes.LARGE,
          height: theme.Spacing.LARGE,
          padding: theme.Spacing.SMALL
        },
        labelText: {
          alignItems: 'center',
          color: theme.Colors.GRAY_700,
          display: 'flex',
          fontSize: theme.FontSizes.SMALL,
          fontFamily: theme.Fonts.SEMIBOLD,
          paddingBottom: isLargeOrMediumWindowSize ? theme.Spacing.MEDIUM : theme.Spacing.XSMALL,
          paddingLeft: theme.Spacing.SMALL,
          paddingRight: theme.Spacing.SMALL,
          paddingTop: isLargeOrMediumWindowSize ? theme.Spacing.MEDIUM : theme.Spacing.XSMALL,
          textAlign: 'left'
        },
        status: {
          paddingBottom: theme.Spacing.XSMALL,
          paddingLeft: isLargeOrMediumWindowSize ? theme.Spacing.SMALL : theme.Spacing.XSMALL,
          paddingRight: theme.Spacing.SMALL,
          paddingTop: theme.Spacing.XSMALL
        },
        success: {
          color: theme.Colors.PRIMARY
        },
        wrapper: _extends({
          borderBottom: _this.props.valid ? '1px solid ' + theme.Colors.GRAY_300 : '1px solid ' + theme.Colors.DANGER,
          boxSizing: 'border-box',
          paddingBottom: theme.Spacing.XSMALL,
          marginLeft: isLargeOrMediumWindowSize ? 0 : -10,
          marginRight: isLargeOrMediumWindowSize ? 0 : -10,
          paddingTop: theme.Spacing.XSMALL,
          transition: 'all .2s ease-in',
          WebkitAppearance: 'none',
          whiteSpace: 'nowrap',
          '&:focus-within': wrapperFocus
        }, _this.props.style),
        wrapperFocus: wrapperFocus
      }, _this.props.styles);
    });
    return _this;
  }
  _createClass(DisplayInput, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      this._labelId = _uniqueId('DI');
      this._inputId = this.props.elementProps.id || _uniqueId('DI');
    }
  }, {
    key: "render",
    value: function render() {
      // Input properties
      var _this$props$elementPr = this.props.elementProps,
        disabled = _this$props$elementPr.disabled,
        onChange = _this$props$elementPr.onChange,
        rest = _objectWithoutProperties(_this$props$elementPr, _excluded);

      // Methods
      var theme = StyleUtils.mergeTheme(this.props.theme);
      var hasChildren = !!this.props.children;
      var isLargeOrMediumWindowSize = this._isLargeOrMediumWindowSize(theme);
      var showHint = this.props.showHint && !this.props.status && isLargeOrMediumWindowSize;
      var hasLabel = !!this.props.label;

      // Column Sizes
      var twoWidthColumn = {
        large: 2,
        medium: 2,
        small: 0
      };
      var inputColumn = this._getInputColumns(hasLabel, showHint);
      var labelColumn = {
        large: 2,
        medium: 3,
        small: 12
      };
      var statusColumn = {
        large: 10,
        medium: 9,
        small: 12
      };

      // Styles
      var styles = this.styles(theme, isLargeOrMediumWindowSize);
      var errorMessage = _get(this.props.status, 'message', null);
      return /*#__PURE__*/React.createElement(Container, {
        className: "mx-display-input",
        styles: styles.container
      }, /*#__PURE__*/React.createElement("div", {
        className: (0, _cssinjs.css)(_objectSpread(_objectSpread({}, styles.wrapper), this.props.isFocused ? styles.wrapperFocus : {}))
      }, /*#__PURE__*/React.createElement(Row, null, this.props.label ? /*#__PURE__*/React.createElement(Column, {
        span: labelColumn
      }, /*#__PURE__*/React.createElement("label", {
        htmlFor: this._inputId,
        id: this._labelId,
        style: _objectSpread(_objectSpread({}, styles.labelText), this.props.labelStyle)
      }, this.props.label)) : null, /*#__PURE__*/React.createElement(Column, {
        relative: !hasChildren,
        span: inputColumn
      }, hasChildren ? /*#__PURE__*/React.createElement("div", {
        style: _objectSpread(_objectSpread({}, styles.children), this.props.childrenStyle)
      }, this.props.children) : /*#__PURE__*/React.createElement("div", {
        style: styles.inputWrapper
      }, /*#__PURE__*/React.createElement("input", _extends({}, rest, {
        "aria-disabled": disabled,
        "aria-label": errorMessage,
        "aria-labelledby": hasLabel && !errorMessage ? this._labelId : null,
        className: (0, _cssinjs.css)(styles.input),
        disabled: disabled,
        id: this._inputId,
        key: "input",
        onChange: disabled ? null : onChange,
        ref: this.props.elementRef
      })))), showHint ? /*#__PURE__*/React.createElement(Column, {
        span: twoWidthColumn
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.hint
      }, this.props.showHint && !this.props.status ? /*#__PURE__*/React.createElement("div", null, this.props.hint) : null)) : null)), /*#__PURE__*/React.createElement(Row, null, this.props.status ? /*#__PURE__*/React.createElement(Column, {
        offset: twoWidthColumn,
        span: statusColumn
      }, /*#__PURE__*/React.createElement("div", {
        style: styles.status
      }, /*#__PURE__*/React.createElement("div", {
        "aria-describedby": this._inputId,
        role: this.props.statusRole,
        style: styles[this.props.status.type]
      }, this.props.status.message))) : null));
    }
  }]);
  return DisplayInput;
}(React.Component);
_defineProperty(DisplayInput, "propTypes", {
  childrenStyle: PropTypes.object,
  elementProps: PropTypes.object,
  elementRef: PropTypes.func,
  hint: PropTypes.string,
  isFocused: PropTypes.bool,
  label: PropTypes.string,
  labelStyle: PropTypes.object,
  placeholder: PropTypes.string,
  showHint: PropTypes.bool,
  status: PropTypes.shape({
    type: PropTypes.string,
    message: PropTypes.string
  }),
  statusRole: PropTypes.string,
  styles: PropTypes.object,
  theme: themeShape,
  valid: PropTypes.bool
});
_defineProperty(DisplayInput, "defaultProps", {
  elementProps: {
    type: 'text'
  },
  isFocused: false,
  statusRole: "alert",
  valid: true
});
module.exports = (0, _Theme.withTheme)(DisplayInput);